F2<-function(data, var, group, HIST=NULL, HISTh=NULL,  breaks=20, varbreak=FALSE, horiz=FALSE, line=FALSE,  lty=1, lwd=2.5, 
ResetPAR=TRUE,  PAR=NULL,  XLAB=NULL, YLAB=NULL, XLIM=NULL,
YLIM=NULL, COLOR=NULL, COLORb="transparent", LEGEND=NULL, AXIS=NULL,MTEXT= NULL, TEXT=NULL){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=var), subset(datos, select=group))



datos<-na.exclude(datosT)


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

dati<-as.character(unique(datos[,2]))


datas<-datos

if(!is.null(COLOR)){
}
else{
COLOR<-rainbow(length(dati))
}





if(!is.null(XLAB)) xlab<-XLAB else xlab<-var


if(!is.null(YLAB)){
ylab<-YLAB
}
else{
ylab<-"Frequency"
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}




if(!is.null(XLIM)){
}
else{
maxx<-max(datos[,1], na.rm=TRUE)
minx<-min(datos[,1], na.rm=TRUE)
XLIM<-c(minx,maxx)
if(horiz==TRUE){
XLIMb<-c(0,breaks)
}
}






catn<-length(unique(dati))



maxden<-0

if(varbreak==TRUE){
for(h in 1:catn){
datos3<-subset(datos, datos[,2]==dati[h])
histog<-hist(datos3[,1], breaks=datos3[,1], plot=FALSE)
maxd<-max(histog$counts)
if(maxd>maxden) maxden<-maxd else maxden<-maxden
}
}
else{
for(h in 1:catn){
datos3<-subset(datos, datos[,2]==dati[h])
histog<-hist(datos3[,1], breaks=breaks, plot=FALSE)
maxd<-max(histog$counts)
if(maxd>maxden) maxden<-maxd else maxden<-maxden
}
}



if(!is.null(YLIM)){
coli<-1
}
else{
coli<-2
YLIM<-c(0,maxden)
}


if(horiz==TRUE){

rango<-range(datos[,var] , na.rm = TRUE)

intervalos<- seq(rango[1], rango[2], by=(rango[2]-rango[1])/breaks)

for(h in 1:catn){
datos3<-subset(datos, datos[,2]==dati[h])


Lm<-as.matrix(datos3)

L.f<-cut(as.numeric(Lm[,1]), intervalos, right=FALSE)
t<-table(L.f)
t<-as.vector(t)


if(coli==2){
if(h==1){
maxh<-max(t)
}
else{
if(maxh>max(t)) YLIM<-c(0,maxh) else YLIM<-c(0,max(t))
}
}#end coli
}#end for
}#end horizontal==TRUE




for(h in 1:catn){
datos3<-subset(datos, datos[,2]==dati[h])
if(h>1){
par(new=TRUE)
}

if(horiz==TRUE){

Lm<-as.matrix(datos3)

L.f<-cut(as.numeric(Lm[,1]), intervalos, right=FALSE)
t<-table(L.f)
t<-as.vector(t)


if(!is.null(HISTh)){
scatterplotexe<-paste("barplot(","height=t,", "horiz=TRUE,",  toString(x=HISTh), ")")
bar<-eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("barplot(","height=t,", "horiz=TRUE,",
"space=0,", "ylim=XLIMb,", "xlim=YLIM,","col=COLORb,",
"border=COLOR[h],","xlab=ylab,", "ylab=xlab",")")
bar<-eval(parse(text=scatterplotexe))
}



}
else{
if(varbreak==TRUE){
if(!is.null(HIST)){
tx<-paste("hist(","x=datos3[,1],", "breaks=datos3[,1],", "freq=TRUE,", toString(x=HIST), ")")
eval(parse(text=tx))
}
else{
tx<-paste("hist(","x=datos3[,1],", "breaks=datos3[,1],", "border=COLOR[h],",
"xlim=XLIM,", "ylim=YLIM,", "xlab=xlab,", "ylab=ylab,", "main='',", "freq=TRUE", ")")
eval(parse(text=tx))
}
}
else{
if(!is.null(HIST)){
tx<-paste("hist(","x=datos3[,1],", "breaks=breaks,", "freq=TRUE,", toString(x=HIST), ")")
eval(parse(text=tx))
}
else{
tx<-paste("hist(","x=datos3[,1],", "breaks=breaks,", "border=COLOR[h],",
"xlim=XLIM,", "ylim=YLIM,", "xlab=xlab,", "ylab=ylab,", "main='',", "freq=TRUE", ")")
eval(parse(text=tx))
}
}
}

llty<-length(lty)

if(llty==1){
pch1<-lty
for (t in 2:catn){
pcht<-lty
pch1<-append(pch1,pcht)
}
lty<-pch1
}
else{
}




if(line==TRUE){
if(varbreak==TRUE){
}
else{
for(h in 1:catn){
datos3<-subset(datos, datos[,2]==dati[h])
histog<-hist(datos3[,1], breaks=breaks, plot=FALSE)
maxd<-max(histog$counts)
mult<-maxd/max(histog$density)
density<-histog$density*mult
lines(x=histog$mid, y=density, col=COLOR[h], lwd=lwd,lty=lty[h])
}
}

}

}


if(horiz==FALSE) lpos<-"topleft" else lpos<-"topright"

if(!is.null(LEGEND)){
if(LEGEND==FALSE){
}
else{
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
}
else{
legendexe<-paste("legend(","x=lpos,","legend=dati,","bty='n',", "col=COLOR,",
"lty=lty", ")")
eval(parse(text=legendexe))
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{

if(horiz==TRUE){

seq1<-seq(from=0, to=length(intervalos)-1)
seq2<-intervalos

if(length(var)>1) meanvar<-mean(colMeans(datos[,var], na.rm=TRUE)) else meanvar<-mean(datos[,var], na.rm=TRUE)
maxvar<-max(datos[,var], na.rm=TRUE)
minvar<-min(datos[,var], na.rm=TRUE)

if(abs(maxvar-meanvar)<=abs(meanvar-minvar)){
sequ<-seq(from=length(seq2), to=1, by=-breaks/5)
}
else{
sequ<-seq(from=1, to=length(seq2), by=breaks/5)
}

dig<-0

if(intervalos[2]-intervalos[1]<1){
dig=1
}

if(intervalos[2]-intervalos[1]<0.5){
dig=2
}

if(intervalos[2]-intervalos[1]<0.1){
dig=2
}

if(intervalos[2]-intervalos[1]<0.01){
dig=3
}

if(intervalos[2]-intervalos[1]<0.001){
dig=4
}

if(intervalos[2]-intervalos[1]<0.0001){
dig=5
}

axis(2,at=seq1[sequ], labels=round(seq2[sequ], digits=dig))
}
}


if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}








}
