F54<-function(data, varX, varY, varZ, group=NULL, mean=FALSE, cexpoint=1, cexmean=1, 
cexaxis=1, cexlab=1.2, segments=TRUE, nseg=5, colseg="grey80", axisd=1, meand=2,
XLAB=NULL, YLAB=NULL, ZLAB=NULL, XLIM=NULL, YLIM=NULL, ZLIM=NULL,
COLOR=NULL, PCH=NULL, FAMILY="Arial", MAR=c(1,1,3,1), LEGEND=NULL,
MTEXT= NULL, TEXT=NULL){



datos<-data

datosT<-data.frame(subset(datos, select=varX), subset(datos, select=varY), subset(datos, select=varZ))


if(!is.null(group)){
datosT<-data.frame(datosT, subset(datos, select=group))

cod<-unique(datosT[,group])

catn<-length(cod)

if(!is.null(COLOR)){
}
else{
COLOR<-rainbow(catn)
}


if(!is.null(PCH)){
}
else{
pch1<-14+1
for (t in 2:catn){
pcht<-14+t
pch1<-append(pch1,pcht)
}
PCH<-pch1
}

}
else{
if(!is.null(PCH)) PCH<-PCH else PCH<-1
if(!is.null(COLOR)) COLOR<-COLOR else COLOR<-"black"
}




datos<-na.exclude(datosT)

dati<-data.frame(subset(datos, select=varX), subset(datos, select=varY), subset(datos, select=varZ))





par(family=FAMILY, mar=MAR)




if(!is.null(XLIM)){
}
else{
XLIM[1]<-min(datos[,varX])
XLIM[2]<-max(datos[,varX])
}



if(!is.null(YLIM)){
}
else{
YLIM[1]<-min(datos[,varY])
YLIM[2]<-max(datos[,varY])
}

if(!is.null(ZLIM)){
}
else{
ZLIM[1]<-min(datos[,varZ])
ZLIM[2]<-max(datos[,varZ])
}


plot(0,0,  cex=0, axes=FALSE, xlab="",ylab="", xlim=c(-0.1,1.1), ylim=c(-0.1,1.1))


m1<-matrix(c(0,0.5,0,1), nrow=2,ncol=2)
recty<-lm(m1[,2]~m1[,1])

m1<-matrix(c(0.5,1,1,0), nrow=2,ncol=2)
rectz<-lm(m1[,2]~m1[,1])

if(segments==TRUE){
inc<-1/nseg
val<-0

for(g in 1:(nseg-1)){
val<-val+inc
segments(val,0,val/2,recty$coefficients[1]+val/2*recty$coefficients[2], col=colseg)
}


val<-1
val1<-1
for(g in 1:(nseg-1)){
val<-val-inc
val1<-val1-inc/2
segments(val,0,val1,rectz$coefficients[1]+(val1)*rectz$coefficients[2], col=colseg)
}

}#End segments

polygon(x=c(0,0.5,1,0), y=c(0,1,0,0))

text(0,0, label=as.character(round(XLIM[1], digits = axisd)), pos=1, cex=cexaxis)
text(1,0, label=as.character(round(XLIM[2], digits = axisd)), pos=1, cex=cexaxis)
text(0,0, label=as.character(round(YLIM[1], digits = axisd)), pos=2, cex=cexaxis)
text(0.5,1, label=as.character(round(YLIM[2], digits = axisd)), pos=2, cex=cexaxis)
text(1,0, label=as.character(round(ZLIM[1], digits = axisd)), pos=4, cex=cexaxis)
text(0.5,1, label=as.character(round(ZLIM[2], digits = axisd)), pos=4, cex=cexaxis)

text(0.5,-0.05, label=XLAB, pos=1, font=2, cex=cexlab)
text(0.2,0.5, label=YLAB, pos=2, font=2, cex=cexlab)
text(0.8,0.5, label=ZLAB, pos=4, font=2, cex=cexlab)



if(!is.null(group)){

for(h in 1:catn){

datas<-subset(datos,datos[,group]==cod[h])

dati<-datas[,1:3]

if(h>1){
par(new=TRUE)
segments<-FALSE
}


m1<-matrix(c(XLIM[1],XLIM[2],0,1), nrow=2,ncol=2)
rrectx<-lm(m1[,2]~m1[,1])
mx<-rrectx$coefficients[1]+ rrectx$coefficients[2]*dati[,1]


m1<-matrix(c(YLIM[1],YLIM[2],0,1), nrow=2,ncol=2)
rrecty<-lm(m1[,2]~m1[,1])
my<-rrecty$coefficients[1]+ rrecty$coefficients[2]*dati[,2]
xy<-(my-recty$coefficients[1])/recty$coefficients[2]

m1<-matrix(c(ZLIM[1],ZLIM[2],0,1), nrow=2,ncol=2)
rrectz<-lm(m1[,2]~m1[,1])
mz<-rrectz$coefficients[1]+ rrectz$coefficients[2]*dati[,3]
xz<-(mz-rectz$coefficients[1])/rectz$coefficients[2]


XX<-(mx+xy+xz)/3
YY<-(my+mz)/3


points(XX,YY, xlim=c(-0.1,1.1), ylim=c(-0.1,1.1), pch=PCH[h], col=COLOR[h], cex=cexpoint)

if(mean==TRUE){
mediax<-0
mediay<-0
m<-apply(dati, 2, mean)
names(m) <- NULL

m1<-matrix(c(XLIM[1],XLIM[2],0,1), nrow=2,ncol=2)
rrectx<-lm(m1[,2]~m1[,1])
mx<-rrectx$coefficients[1]+ rrectx$coefficients[2]*m[1]



mediax<-mediax+mx
mediay<-mediay+0

m1<-matrix(c(YLIM[1],YLIM[2],0,1), nrow=2,ncol=2)
rrecty<-lm(m1[,2]~m1[,1])
my<-rrecty$coefficients[1]+ rrecty$coefficients[2]*m[2]

xy<-(my-recty$coefficients[1])/recty$coefficients[2]



mediax<-mediax+xy
mediay<-mediay+my


m1<-matrix(c(ZLIM[1],ZLIM[2],0,1), nrow=2,ncol=2)
rrectz<-lm(m1[,2]~m1[,1])
mz<-rrectz$coefficients[1]+ rrectz$coefficients[2]*m[3]

xz<-(mz-rectz$coefficients[1])/rectz$coefficients[2]



mediax<-mediax+xz
mediay<-mediay+mz

mediax<-mediax/3
mediay<-mediay/3

points(mediax, mediay, pch =16, cex = cexpoint+0.5, col="black")

segments(mx,0, mediax,mediay)
segments(xy,my, mediax,mediay)
segments(xz,mz, mediax,mediay)


points(mx, 0, pch = PCH[h], cex = cexpoint+0.5, col=COLOR[h])
text(mx, 0, labels = as.character(round(m[1], digits = meand)), cex = cexmean, pos = 1)

points(xy, my, pch = PCH[h], cex = cexpoint+0.5, col=COLOR[h])
text(xy, my, labels = as.character(round(m[2], digits = meand)), cex = cexmean, pos = 2)

points(xz, mz, pch =PCH[h], cex = cexpoint+0.5, col=COLOR[h])
text(xz, mz, labels = as.character(round(m[3], digits = meand)), cex = cexmean, pos = 4)


}#End mean TRUE



}#End for catn

}

else{


m1<-matrix(c(XLIM[1],XLIM[2],0,1), nrow=2,ncol=2)
rrectx<-lm(m1[,2]~m1[,1])
mx<-rrectx$coefficients[1]+ rrectx$coefficients[2]*datos[,1]


m1<-matrix(c(YLIM[1],YLIM[2],0,1), nrow=2,ncol=2)
rrecty<-lm(m1[,2]~m1[,1])
my<-rrecty$coefficients[1]+ rrecty$coefficients[2]*datos[,2]
xy<-(my-recty$coefficients[1])/recty$coefficients[2]

m1<-matrix(c(ZLIM[1],ZLIM[2],0,1), nrow=2,ncol=2)
rrectz<-lm(m1[,2]~m1[,1])
mz<-rrectz$coefficients[1]+ rrectz$coefficients[2]*datos[,3]
xz<-(mz-rectz$coefficients[1])/rectz$coefficients[2]


XX<-(mx+xy+xz)/3
YY<-(my+mz)/3



points(XX,YY, xlim=c(-0.1,1.1), ylim=c(-0.1,1.1), pch=PCH, col=COLOR, cex=cexpoint)


if(mean==TRUE){
mediax<-0
mediay<-0
m<-apply(datos, 2, mean)
names(m) <- NULL

m1<-matrix(c(XLIM[1],XLIM[2],0,1), nrow=2,ncol=2)
rrectx<-lm(m1[,2]~m1[,1])
mx<-rrectx$coefficients[1]+ rrectx$coefficients[2]*m[1]



mediax<-mediax+mx
mediay<-mediay+0

m1<-matrix(c(YLIM[1],YLIM[2],0,1), nrow=2,ncol=2)
rrecty<-lm(m1[,2]~m1[,1])
my<-rrecty$coefficients[1]+ rrecty$coefficients[2]*m[2]

xy<-(my-recty$coefficients[1])/recty$coefficients[2]



mediax<-mediax+xy
mediay<-mediay+my


m1<-matrix(c(ZLIM[1],ZLIM[2],0,1), nrow=2,ncol=2)
rrectz<-lm(m1[,2]~m1[,1])
mz<-rrectz$coefficients[1]+ rrectz$coefficients[2]*m[3]

xz<-(mz-rectz$coefficients[1])/rectz$coefficients[2]



mediax<-mediax+xz
mediay<-mediay+mz

mediax<-mediax/3
mediay<-mediay/3

points(mediax, mediay, pch =16, cex = cexpoint+0.5, col="black")

segments(mx,0, mediax,mediay)
segments(xy,my, mediax,mediay)
segments(xz,mz, mediax,mediay)


points(mx, 0, pch = 16, cex = cexpoint+0.5, col=COLOR)
text(mx, 0, labels = as.character(round(m[1], digits = meand)), cex = cexmean, pos = 1)

points(xy, my, pch = 16, cex = cexpoint+0.5, col=COLOR)
text(xy, my, labels = as.character(round(m[2], digits = meand)), cex = cexmean, pos = 2)

points(xz, mz, pch =16, cex = cexpoint+0.5, col=COLOR)
text(xz, mz, labels = as.character(round(m[3], digits = meand)), cex = cexmean, pos = 4)


}#End mean TRUE


}#End group



if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}





if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
if(!is.null(group)){
legendexe<-paste("legend(","x=-0.1,","y=1.05,", "legend=cod,","bty='n',", "col=COLOR,",
"pch=PCH", ")")
eval(parse(text=legendexe))
}
}




}
