F56<-function(data, varX, varY, OrderCatX=NULL, LabelCatX=NULL, 
OrderCatY=NULL, LabelCatY=NULL, shade=TRUE, cex.axis=1,
MPLOT=NULL,  ResetPAR=TRUE,  PAR=NULL,
XLAB=NULL, YLAB=NULL,  COLOR=NULL){



if (missing(OrderCatY)) OrderCatY=NULL else OrderCatY=OrderCatY
if (missing(LabelCatY)) LabelCatY=OrderCatY else LabelCatY=LabelCatY
if (missing(OrderCatX)) OrderCatX=NULL else OrderCatX=OrderCatX
if (missing(LabelCatX)) LabelCatX=OrderCatX else LabelCatX=LabelCatX

datos<-data

datosT<-data.frame(subset(datos, select=varX), subset(datos, select=varY))

datos<-na.exclude(datosT)

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY


if(!is.null(OrderCatY)){
datos[,varY]<-factor(datos[,varY], levels = OrderCatY, labels = LabelCatY)
}
else{

if(!is.null(LabelCatY)) datos[,varY]<-factor(datos[,varY], levels = unique(datos[,varY]), labels = LabelCatY) else datos<-datos
}

if(!is.null(OrderCatX)){
datos[,varX]<-factor(datos[,varX], levels = OrderCatX, labels = LabelCatX)
}
else{

if(!is.null(LabelCatX)) datos[,varX]<-factor(datos[,varX], levels = unique(datos[,varX]), labels = LabelCatX) else datos<-datos
}


if(!is.null(MPLOT)){
mplot<-paste("mosaicplot(","datos[,varX]~datos[,varY],", toString(x=MPLOT), ")")
eval(parse(text=mplot))
}
else{
mplot<-paste("mosaicplot(","datos[,varX]~datos[,varY],","xlab=xlab,","ylab=ylab,",
"shade=shade,", "main='',", "color=COLOR,", "cex.axis=cex.axis,", ")")
eval(parse(text=mplot))
}






}
