F85<-function(data, FactorX, varY, varY1=NULL, varY2=NULL, varY3=NULL, method="mean", dev="sd", type=NULL,
MAR1=c(5,5,3,4), MAR2=c(5,5,3,8), MAR3=c(5,5,3,12),
ResetPAR=TRUE, PAR=NULL, order=NULL, OrderCat=NULL, LabelCat=NULL,
XLAB=NULL, YLAB=NULL, YLAB1=NULL, YLAB2=NULL,YLAB3=NULL, XLIM=NULL,
YLIM=NULL, YLIM1=NULL, YLIM2=NULL, YLIM3=NULL, CEX=1.4, FONTLAB=2, CEXLAB=1.5, COLOR=NULL,
COLORI="black", PCH=NULL, ltyL=NULL,  lwdL=1,  LEGEND=NULL,  MTEXT= NULL, TEXT=NULL){



############
#################Function to add axes
############

AA<-function(data,  FactorX, varY,   method="mean", dev="sd", type=NULL,
order=NULL, OrderCat=NULL, LabelCat=NULL, 
XLAB=NULL, YLAB=NULL, XLIM=NULL, YLIM=NULL, CEX=1.2, FONTLAB=2, CEXLAB=1.5, COLOR=NULL,
COLORI="black", PCH=NULL, ltyL=NULL,  lwdL=1, PLOT=NULL, axess=TRUE, add=TRUE){

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=FactorX))

datos<-na.exclude(datosT)


if(is.null(LabelCat)) LabelCat=OrderCat else LabelCat=LabelCat



if(!is.null(XLAB)) xlab<-XLAB else xlab<-FactorX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY


datos[,FactorX]<-factor(datos[,FactorX], levels = unique(datos[,FactorX]), labels = unique(datos[,FactorX]))




if(!is.null(method)) {
median<- tapply(datos[, varY], datos[, FactorX], method)
}
else{
median<- tapply(datos[, varY], datos[, FactorX], median)
}


if(!is.null(OrderCat)){
datos[,FactorX]<-factor(datos[,FactorX], levels = OrderCat, labels = LabelCat)
}
else{
if(!is.null(order)){
if(order=="decreasing") names<-names(sort(median, decreasing=TRUE)) else names<-names(sort(median, decreasing=FALSE))

if(order=="alphaAZ") names<-sort(names, decreasing=FALSE) else names<-names

if(order=="alphaZA") names<-sort(names, decreasing=TRUE) else names<-names


if(!is.null(LabelCat))  LabelCat<-LabelCat else LabelCat<-names
datos[,FactorX]<-factor(datos[,FactorX], levels = names, labels = LabelCat)
}
else{
if(!is.null(LabelCat)) datos[,FactorX]<-factor(datos[,FactorX], levels = unique(datos[,FactorX]), labels = LabelCat) else datos<-datos
}
}


if(!is.null(method)) {

rb <- boxplot(datos[,varY] ~ datos[,FactorX], col = "transparent" , border = "transparent", xlab=xlab, ylab=ylab, xlim=XLIM, ylim=YLIM, axes=axess)

mn.t <- tapply(datos[, varY], datos[, FactorX], method)
length<-tapply(datos[, varY], datos[, FactorX], length)
sd.t <- tapply(datos[, varY], datos[, FactorX], sd)
if(dev=="sd"){
sd.t <- tapply(datos[, varY], datos[, FactorX], sd)
}
else{
sd.t<-sd.t/sqrt(length)
}
xi <- seq(rb$n)


points(xi, mn.t, col = COLOR, pch = PCH, cex=CEX, type=type, lty=ltyL, lwd=lwdL)
arrows(xi, mn.t - sd.t, xi, mn.t + sd.t, code = 3, col = COLORI, angle = 90, length = .1)
}
else{

method="mean"
rb <- boxplot(datos[,varY] ~ datos[,FactorX], col = "transparent" , border = "transparent", xlab=xlab, ylab=ylab, xlim=XLIM, ylim=YLIM, axes=axess)
mn.t <- tapply(datos[, varY], datos[, FactorX], method)
xi <- seq(rb$n)



if(add==TRUE){
rb <- boxplot(datos[,varY] ~ datos[,FactorX], col = "transparent" , border = "transparent", xlab=xlab,
ylab=ylab, add=TRUE, xlim=XLIM, ylim=YLIM, axes=axess)
}

points(datos[,FactorX], datos[,varY], col = COLOR, pch = PCH, cex=CEX, type="p", lty=ltyL, lwd=lwdL, xlim=XLIM, ylim=YLIM)

points(xi, mn.t, col = COLOR, pch = PCH, cex=CEX, type=type, lty=ltyL, lwd=lwdL)

}

}


##################
##################
##################End function AA


variables<-c(varY,varY1,varY2,varY3)
nvar<-length(variables)

if(is.null(PCH)){
PCH<-seq(15,15+nvar,1)
}

if(is.null(type)){
type<-rep("b",nvar)
}


if(is.null(ltyL)){
ltyL<-rep(1,nvar)
}


if(is.null(COLOR)){
COLOR<-rainbow(nvar)
}


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

mar<-c(5,5,3,2)

if(!is.null(varY1)){
mar<-MAR1
}

if(!is.null(varY2)){
mar<-MAR2
}

if(!is.null(varY3)){
mar<-MAR3
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{

par(font.lab=FONTLAB, mar=mar,cex.lab=CEXLAB)
}

AA(data=data,  FactorX=FactorX, varY=varY,   method=method, dev=dev, type=type[1],
order=order, OrderCat=OrderCat, LabelCat=LabelCat,
XLAB=XLAB, YLAB=YLAB, XLIM=XLIM, YLIM=YLIM, CEX=CEX, FONTLAB=FONTLAB, CEXLAB=CEXLAB, COLOR=COLOR[1],
COLORI=COLORI, PCH=PCH[1], ltyL=ltyL[1],  lwdL=lwdL,PLOT=NULL, axess=TRUE, add=TRUE)


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=variables,","bty='n',", "lty=ltyL,", "col=COLOR,",
"pch=PCH", ")")
eval(parse(text=legendexe))
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



if(!is.null(varY1)){
par(new=TRUE)


PLOT=c("type='p'", "lty=ltyL", "lwd=lwdL", "xaxt='n'", "yaxt='n'", "xlab=xlab", "ylab=ylab", "col=COLOR", "xlim=XLIM", "ylim=YLIM1", "cex=CEX", "pch=PCH")

AA(data=data,  FactorX=FactorX, varY=varY1,   method=method, dev=dev, type=type[2],
order=order, OrderCat=OrderCat, LabelCat=LabelCat,
XLAB="", YLAB="",  XLIM=XLIM, YLIM=YLIM1, CEX=CEX, FONTLAB=FONTLAB, CEXLAB=CEXLAB, COLOR=COLOR[2],
COLORI=COLORI, PCH=PCH[2], ltyL=ltyL[2],  lwdL=lwdL,  PLOT=PLOT, axess=FALSE, add=FALSE)

if(!is.null(YLAB1)) ylab=YLAB1 else ylab=varY1


axis(4)
mtext(ylab,4,line=2.5, font=FONTLAB, cex=CEXLAB)
}

if(!is.null(varY2)){
par(new=TRUE)


PLOT=c("type='p'", "lty=ltyL", "lwd=lwdL", "xaxt='n'", "yaxt='n'", "xlab=xlab", "ylab=ylab", "col=COLOR", "xlim=XLIM", "ylim=YLIM2", "cex=CEX", "pch=PCH")

AA(data=data,  FactorX=FactorX, varY=varY2,   method=method, dev=dev, type=type[3],
order=order, OrderCat=OrderCat, LabelCat=LabelCat,
XLAB="", YLAB="", XLIM=XLIM, YLIM=YLIM2, CEX=CEX, FONTLAB=FONTLAB, CEXLAB=CEXLAB, COLOR=COLOR[3],
COLORI=COLORI, PCH=PCH[3], ltyL=ltyL[3],  lwdL=lwdL, PLOT=PLOT, axess=FALSE, add=FALSE)

if(!is.null(YLAB2)) ylab=YLAB2 else ylab=varY2

axis(4, line=4)
mtext(ylab,4,line=6.5, font=FONTLAB, cex=CEXLAB)
}


if(!is.null(varY3)){
par(new=TRUE)


PLOT=c("type='p'", "lty=ltyL", "lwd=lwdL", "xaxt='n'", "yaxt='n'", "xlab=xlab", "ylab=ylab", "col=COLOR", "xlim=XLIM", "ylim=YLIM3", "cex=CEX", "pch=PCH")

AA(data=data,  FactorX=FactorX, varY=varY3,   method=method, dev=dev, type=type[4],
order=order, OrderCat=OrderCat, LabelCat=LabelCat,
XLAB="", YLAB="",   XLIM=XLIM, YLIM=YLIM3, CEX=CEX, FONTLAB=FONTLAB, CEXLAB=CEXLAB, COLOR=COLOR[4],
COLORI=COLORI, PCH=PCH[4], ltyL=ltyL[4],  lwdL=lwdL,PLOT=PLOT, axess=FALSE, add=FALSE)

if(!is.null(YLAB3)) ylab=YLAB3 else ylab=varY3

axis(4, line=8)
mtext(ylab,4,line=10.5, font=FONTLAB, cex=CEXLAB)
}



}
