\name{Z8}
\docType{data}
\alias{Z8}
\encoding{latin1}
\title{MORPHOMETRIC VARIABLES OF FRESHWATER FISHES}
\usage{data(Z8)}
\description{Morphometric data of several species of 
three families of freshwater fishes, as the length of the dorsal fin base (M12), body height (M11), etc. For details see Guisande et al. (2010).} 
\format{An data frame with 31 columns: taxonomic data (order, family, genus and species) and 26 morphometric variables.}
\source{\url{http://www.ipez.es}.}
\references{
Guisande, C., Manjarrs-Hernndez, A., Pelayo-Villamil, P., Granado-Lorencio, C., Riveiro, I., Acua, A., Prieto-Piraquive, E., Janeiro, E., Matas, J.M., Patti, C., Patti, B., Mazzola, S., Jimnez, S., Duque, V. & Salmern, F. (2010) IPez: An expert system for the taxonomic identification of fishes based on machine learning techniques. \emph{Fisheries Research}, 102, 240-247.}
\keyword{Z8}
