F10<-function(data, var, labels, order=NULL, percut=NULL, per=FALSE,
ResetPAR=TRUE, PAR=NULL,  PIE=NULL,
COLOR=NULL, MTEXT= NULL, TEXT=NULL){



###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=var), subset(datos, select=labels))

datos<-na.exclude(datosT)


suma<-sum(datos[,var])
var1<-datos[,var]*100/suma

datos<-cbind(datos,var1)

if(!is.null(percut)){
datos<-subset(datos,(var1 > percut))
}


if(!is.null(order)){

if(order=="decreasing") datos<-datos[order(datos[,1], decreasing=TRUE), ] else datos<-datos[order(datos[,1], decreasing=FALSE), ]

if(order=="alphaAZ") datos<-datos[order(datos[,2], decreasing=FALSE), ] else datos<-datos

if(order=="alphaZA") datos<-datos[order(datos[,2], decreasing=TRUE), ] else datos<-datos

}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.3)
}


if(!is.null(COLOR)){
color<-COLOR
}
else{
color<-terrain.colors(length(unique(datos[,labels])))
}

if(per==TRUE) etiq<-paste(datos[,labels]," - ", format(datos[,3], digits=2), "%", sep="") else etiq<-paste(datos[,labels])

if(!is.null(PIE)){
pieexe<-paste("pie(","x=datos[,var],","labels=etiq,",toString(x=PIE), ")")
eval(parse(text=pieexe))
}
else{
pieexe<-paste("pie(","x=datos[,var],","labels=etiq,",
"col=color",")")
eval(parse(text=pieexe))
}


if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}







}
