F29<-function(data, ref, models, pos.cor=TRUE, TAYLOR=NULL,
ResetPAR=TRUE, PAR=NULL,  COLOR=NULL, PCH=NULL, CEXPCH=1.4, 
LEGEND=NULL, MTEXT= NULL, TEXT=NULL){



###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=ref), subset(datos, select=models))

datos<-na.exclude(datosT)



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}




if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.3)
}

dati<-datos[,models]
d1<-dim(dati)

if(!is.null(COLOR)) color<-COLOR else color<-rainbow(d1[2])

pcht<-14+1
for (t in 1:d1[2]){#Bucle 1
pch<-14+t
if(t==1){
pcht<-pcht
legendt<-paste("' ",models[1],"'")
ltyT<-t
}
else{
pcht<-append(pcht,pch)
legendt<-paste(legendt,",","'",models[t],"'")
ltyT<-append(ltyT,t)
}
}#Fin bucle 1


legendT<-scan(what=character(0), sep=",", file=textConnection(legendt)) 

if(!is.null(TAYLOR)){
beanplotexe<-paste("plotrix::taylor.diagram(","ref=datos[,ref],","model=datos[,models[1]],", toString(x=TAYLOR), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("plotrix::taylor.diagram(","ref=datos[,ref],","model=datos[,models[1]],", "add=FALSE,",
"col=color[1],",  "pch=pcht[1],", "pos.cor=pos.cor,", "sd.arcs = TRUE,", "ref.sd=TRUE,", "pcex=CEXPCH",")")
eval(parse(text=beanplotexe))
}




for (t in 2:d1[2]){#Bucle 2


beanplotexe<-paste("plotrix::taylor.diagram(","ref=datos[,ref],","model=datos[,models[t]],", "add=TRUE,",
"col=color[t],",  "pch=pcht[t],", "pos.cor=pos.cor,", "sd.arcs = TRUE,", "ref.sd=TRUE,", "pcex=CEXPCH",")")
eval(parse(text=beanplotexe))


}#Fin del bucle 2

if(!is.null(PCH)) pcht<-PCH else pcht<-pcht

if(!is.null(LEGEND)) xcxcddf<-1 else  legend(x = "topleft" , legend=legendT, bty = "n", pch=c(pcht),
col=color,pt.cex=1.5, lty=c(ltyT))

if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))


if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 1
else{
}



}
