F42<-function(data, varZ,  varY, varX, PLOT3D=NULL, CEX=2, COLOR="red",
ZLAB=NULL, YLAB=NULL, XLAB=NULL, ZLIM=NULL, YLIM=NULL, XLIM=NULL){



datos<-data

datosT<-data.frame(subset(datos, select=varZ), subset(datos, select=varY), subset(datos, select=varX))


datos<-na.exclude(datosT)



if(!is.null(ZLAB)) zlab<-ZLAB else zlab<-varZ
if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY

if(!is.null(XLIM)){
}
else{
max<-max(datos[,varX], na.rm=TRUE)+max(datos[,varX], na.rm=TRUE)*1/100
min<-min(datos[,varX], na.rm=TRUE)-min(datos[,varX], na.rm=TRUE)*1/100
XLIM<-c(min,max)
}

if(!is.null(ZLIM)){
}
else{
max<-max(datos[,varZ], na.rm=TRUE)+max(datos[,varZ], na.rm=TRUE)*1/100
min<-min(datos[,varZ], na.rm=TRUE)-min(datos[,varZ], na.rm=TRUE)*1/100
ZLIM<-c(min,max)
}


if(!is.null(YLIM)){
}
else{
max<-max(datos[,varY], na.rm=TRUE)+max(datos[,varY], na.rm=TRUE)*1/100
min<-min(datos[,varY], na.rm=TRUE)-min(datos[,varY], na.rm=TRUE)*1/100
YLIM<-c(min,max)
}





if(!is.null(PLOT3D)){
tx<-paste("rgl::plot3d(","x=datos[,c(varX,varY,varZ)],", toString(x=PLOT3D), ")")
eval(parse(text=tx))
}
else{
tx<-paste("rgl::plot3d(","x=datos[,c(varX,varY,varZ)],", "col=COLOR,", "type='s',",
"zlim=ZLIM,", "ylim=YLIM,", "xlim=XLIM,", "xlab=xlab,", "xyab=ylab,","zlab=zlab,","size=CEX", ")")
eval(parse(text=tx))
}


}
