F51<-function(data, varY.1, varX.1, cat.1,  varY.2=NULL, varX.2=NULL, cat.2=NULL, labels=NULL, scale=TRUE,
ellipse=FALSE, convex=FALSE, SCATTERPLOT=NULL, LABEL=NULL, ResetPAR=TRUE,  PAR=NULL,
 XLAB=NULL, YLAB=NULL, XLIM1=NULL, YLIM1=NULL, PCH=NULL, COLOR=NULL, 
LEGEND=NULL, MTEXT= NULL, TEXT1=NULL,  ARROWS=NULL, XLIM2=NULL, YLIM2=NULL, TEXT2=NULL){



datos<-data

datosT<-data.frame(subset(datos, select=cat.1), subset(datos, select=varY.1), subset(datos, select=varX.1))

if(!is.null(labels)){
datosT<-data.frame(datosT, subset(datos, select=labels))
}

datos<-na.exclude(datosT)

datos[,1]<-as.character(datos[,1])

dati<-as.character(unique(datos[,cat.1]))

#####convex
if(!is.null(COLOR)){
color1<-COLOR
}
else{
if(convex==TRUE) color1<-rainbow(length(dati), alpha=0.4) else color1<-rainbow(length(dati))
}
#######



catn<-length(dati)

pch1<-14+1
for (t in 2:catn){
pcht<-14+t
pch1<-append(pch1,pcht)
}

if(!is.null(PCH)) pcht<-PCH else pcht<-pch1


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX.1


if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY.1




if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(!is.null(labels)){
colnames(datos)<-c("Group","Y","X","labels")
}
else{
colnames(datos)<-c("Group","Y","X")
}


datos<-datos[order(datos[,1]), ]

datos[,1]<-as.factor(datos[,1])


if(!is.null(SCATTERPLOT)){
scatterplotexe<-paste("car::scatterplot(","Y~X| Group,", "data=datos,", toString(x=SCATTERPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("car::scatterplot(","Y~X| Group,", "data=datos,", "regLine=FALSE,", 
"smooth=FALSE,", "spread=FALSE,", "span= 1," ,"grid=FALSE,", "xlab=xlab,","ylab=ylab,","xlim=XLIM1,","ylim=YLIM1,",
"boxplots=FALSE,", "by.groups=TRUE,", "ellipse=ellipse,", "col=color1,", "pch=pcht,","legend=list(coords=c(x=500000000,y=500000000))", ")")
eval(parse(text=scatterplotexe))
}



dati<-as.character(unique(datos[,1]))

####Convex
if(convex==TRUE){
for(zz in 1:catn){
datis<-subset(datos,(Group == dati[zz]))
hpts <- chull(x=datis[,"X"], y=datis[,"Y"])
hpts <- c(hpts, hpts[1])
datiss<-datis[hpts,]
polygon(datiss[,3],datiss[,2], col=color1[zz], border=NA)
}
}
####


if(!is.null(labels)){
if(!is.null(LABEL)){
tx<-paste("text(","x=datos[,3],", "y=datos[,2],", "labels=datos[,4],", toString(x=LABEL), ")")
eval(parse(text=tx))
}
else{
tx<-paste("text(","x=datos[,3],", "y=datos[,2],", "labels=datos[,4],", "pos=1", ")")
eval(parse(text=tx))
}
}


if(!is.null(TEXT1)){
textexe<-paste("text(",toString(x=TEXT1), ")")
eval(parse(text=textexe))
}
else{
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=unique(datos[,'Group']),", "bty='n',", "col=color1,",
"pch=pcht", ")")
eval(parse(text=legendexe))
}


if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}


#ARROWS

if(!is.null(cat.2)){

datosa<-datos


if(!is.null(XLIM1)){
XLIM1.1<-XLIM1[1]
XLIM1.2<-XLIM1[2]
}
else{
XLIM1.1<-min(datosa[,3])
XLIM1.2<-max(datosa[,3])
}

if(!is.null(YLIM1)){
YLIM1.1<-YLIM1[1]
YLIM1.2<-YLIM1[2]
}
else{
YLIM1.1<-min(datosa[,2])
YLIM1.2<-max(datosa[,2])
}


datos<-data

datosT<-data.frame(subset(datos, select=cat.2), subset(datos, select=varY.2), subset(datos, select=varX.2))



datos<-na.exclude(datosT)
datos[,1]<-as.factor(datos[,1])
datos[,1]<-as.character(datos[,1])
datos[,2]<-as.numeric(datos[,2])
datos[,3]<-as.numeric(datos[,3])

dima<-dim(datos)


if(!is.null(XLIM2)){
minsx<-XLIM2[1]
maxsx<-XLIM2[2]
}
else{
minsx<-min(datos[,3])
maxsx<-max(datos[,3])
}

print("2")
if(!is.null(YLIM2)){
minsy<-YLIM2[1]
maxsy<-YLIM2[2]
}
else{
minsy<-min(datos[,2])
maxsy<-max(datos[,2])
}

meanx<-(minsx+maxsx)/2
meany<-(minsy+maxsy)/2

ranx2<-maxsx-minsx
rany2<-maxsy-minsy

ranx1<-XLIM1.2-XLIM1.1
rany1<-YLIM1.2-YLIM1.1



if(scale==TRUE){
lonx<-ranx1/ranx2*0.5
lony<-rany1/rany2*0.5
}
else{
lonx<-1
lony<-1
}



for(zz in 1:dima[1]){
if(!is.null(ARROWS)){
arrowsexe<-paste("IDPmisc::Arrows(","x1=meanx,", "y1=meany,", "x2=datos[zz,3]*lonx,", "y2=datos[zz,2]*lony,", toString(x=ARROWS), ")")
eval(parse(text=arrowsexe))
}
else{
arrowsexe<-paste("IDPmisc::Arrows(","x1=meanx,", "y1=meany,", "x2=datos[zz,3]*lonx,", "y2=datos[zz,2]*lony,", "open=FALSE", ")")
eval(parse(text=arrowsexe))
}

if(datos[zz,3]>meanx & datos[zz,2]>meany){
pos<-3
}

if(datos[zz,3]<=meanx & datos[zz,2]<=meany){
pos<-1
}

if(datos[zz,3]<=meanx & datos[zz,2]>meany){
pos<-2
}


if(datos[zz,3]>meanx & datos[zz,2]<=meany){
pos<-4
}

if(!is.null(TEXT2)){
textexe<-paste("text(","x=datos[zz,3]*lonx,", "y=datos[zz,2]*lony,", "labels = datos[zz,1],", "pos=pos,", toString(x=TEXT2), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=datos[zz,3]*lonx,", "y=datos[zz,2]*lony,", "labels = datos[zz,1],", "pos=pos", ")")
eval(parse(text=textexe))
}
}

}#Arrows

}
