F55<-function(data, varQuali, varQuanti, OrderCat=NULL, LabelCat=NULL, font.lab=2,
cex.lab=14,  ylab_tol=0.05, bw="nrd0", n=512,  main="", margins=c(5.1, 4.1, 4.1, 3.1),
XLAB=NULL, YLAB=NULL, XLIM=NULL, COLOR=NULL){



if (missing(OrderCat)) OrderCat=NULL else OrderCat=OrderCat
if (missing(LabelCat)) LabelCat=OrderCat else LabelCat=LabelCat


datos<-data

datosT<-data.frame(subset(datos, select=varQuali), subset(datos, select=varQuanti))

datos<-na.exclude(datosT)

if(!is.null(COLOR)){
}
else{
COLOR<-rainbow(length(unique(datos[,varQuali])))
}

if(!is.null(XLAB)) xlab<-XLAB else xlab<-varQuanti

if(!is.null(YLAB)) ylab<-YLAB else ylab<-varQuali

if(!is.null(OrderCat)){
datos[,varQuali]<-factor(datos[,varQuali], levels = OrderCat, labels = LabelCat)
}
else{

if(!is.null(LabelCat)) datos[,varQuali]<-factor(datos[,varQuali], levels = unique(datos[,varQuali]), labels = LabelCat) else datos<-datos
}


vcd::cd_plot(datos[,varQuali]~datos[,varQuanti],  data=datos, xlab="", ylab="", pop=FALSE,
from=XLIM[1], to=XLIM[2], gp=gpar(fill=COLOR),
ylab_tol = ylab_tol, bw = bw, n = n,  main = main, margins = margins)



grid.text(xlab, y = unit(-3.5, "lines"), gp=gpar(fontface=font.lab, fontsize=cex.lab))


grid.text(ylab, x = unit(-3, "lines"), rot = 90, gp=gpar(fontface=font.lab, fontsize=cex.lab))





}
