F67<-function(data, date, var, year, month,
date.format="%d/%m/%Y %H:%M", tzone = NULL, normalise=FALSE, 
type = "default", difference=FALSE, name.pol=var, SUB=NULL, XLAB=c("hour", "hour", "month", "weekday"),
YLAB=NULL, COLOR="hue", STATISTIC="mean",  CI=TRUE, TIMEV=NULL, dec=","){


###############################################
#Seccion que realiza el procedimiento
###############################################



datos<-data

cn<-colnames(datos)
pos<-which(cn==date)
colnames(datos)[pos]<-"date"



if(class(datos$date)=="factor" | class(datos$date)=="character"){
datos$date<-as.POSIXct(strptime(datos$date, format = date.format))
}


if(class(datos$date)=="Date" | class(datos$date)=="POSIXt" | class(datos$date)=="POSIXct"){
if(date.format=="%d/%m/%Y %H:%M"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), " " ,format(datos$date, "%H"), ":", format(datos$date, "%M"), sep="")
}

if(date.format=="%d/%m/%Y"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), sep="")
}

if(date.format=="%Y/%m/%d %H:%M"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), " " ,format(datos$date, "%H"), ":", format(datos$date, "%M"), sep="")
}

if(date.format=="%Y/%m/%d"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), sep="")
}

}



if(date.format=="%Y/%m/%d %H:%M"){ date.format<-"%d/%m/%Y %H:%M"}

if(date.format=="%Y/%m/%d"){ date.format<-"%d/%m/%Y"}


if(dec=="."){
write.csv(x=datos,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos<-openair::import(file="Temp.csv", sep=",", date.format=date.format)
}
else{
datos<-openair::import(file="Temp.csv", sep=";", date.format=date.format)
}


if(class(datos$date)=="factor" | class(datos$date)=="character"){
datos$date<-as.POSIXct(strptime(datos$date, format = date.format))
}


if (missing(year)) {
}
else{
datos<-openair::selectByDate(datos, year = year)
}
if (missing(month)) {
}
else{
datos<-openair::selectByDate(datos, month = month)
}


cn<-colnames(datos)
pos<-which(cn=="date")

datos2<-datos

datos1<-datos[,-pos]

if(dec=="."){
write.csv(x=datos1,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos1,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos1<-read.csv(file="Temp.csv")
}
else{
datos1<-read.csv2(file="Temp.csv")
}

datos<-cbind(datos2[,pos],datos1)
cn<-colnames(datos1)

colnames(datos)<-c("date",cn)

remove(datos1)

remove(datos2)

lt<-length(var)
tx<-var[1]
if(lt>1){
for(ty in 2:lt){
tx<-paste(tx,"/",var[ty], sep=" ")
}
}

if(!is.null(YLAB)) ylab<-YLAB else ylab<-tx

if(!is.null(TIMEV)){
prose<-paste("openair::timeVariation(","mydata=datos,", "pollutant=var,", toString(x=TIMEV), ")")
eval(parse(text=prose))
}
else{
if(!is.null(SUB)){
prose<-paste("openair::timeVariation(","mydata=datos,", "pollutant=var,",
"xlab=XLAB,","normalise=normalise,", "type = type,", "statistic=STATISTIC,",
"cols=COLOR,", "ci=CI,","difference=difference,", "name.pol=name.pol,", 
"ylab=ylab,", "sub=SUB,", "local.tz=tzone", ")")
}
else {
prose<-paste("openair::timeVariation(","mydata=datos,", "pollutant=var,",
"xlab=XLAB,","normalise=normalise,", "type = type,", "statistic=STATISTIC,",
"cols=COLOR,", "ci=CI,","difference=difference,", "name.pol=name.pol,",
"ylab=ylab,", "local.tz=tzone",  ")")
}
eval(parse(text=prose))
}





}
