F73<-function(data, X, Y, Z,  IMAGE=NULL,  XLAB=NULL, YLAB=NULL, ZLAB=NULL,
COL=rev(heat.colors(100)), ResetPAR=TRUE, PAR=NULL,  MTEXT= NULL, TEXT=NULL){

datos<-data
type=1

zlab=""


if(missing(Z)) Z<-datos else Z<-Z



if(class(Z)=="matrix"){
z<-Z
}

if(class(Z)=="character"){

if(length(Z)>1){
z<-as.matrix(datos[Z])
}


if(length(Z)==1){
z<-akima::interp(datos[,X], datos[,Y], datos[,Z], duplicate= "mean")
type=2
if(is.null(ZLAB)){
zlab=Z
}
else{
zlab=ZLAB
}
}

}



if(!missing(X)){
if(!is.null(XLAB)) xlab<-XLAB else xlab<-X
if(!is.null(YLAB)) ylab<-YLAB else ylab<-Y
x<-datos[,X]
y<-datos[,Y]
}
else{
xlab=""
ylab=""
x = seq(0, 1, length.out = nrow(z))
y = seq(0, 1, length.out = ncol(z))
}


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


if(type==1){
if(!is.null(IMAGE)){
tx<-paste("plot3D::image2D(", "z=z,", "x=x,", "y=y,", toString(x=IMAGE), ")")
eval(parse(text=tx))
}
else{
tx<-paste("plot3D::image2D(", "z=z,", "x=x,", "y=y,", "xlab=xlab,", "ylab=ylab,", "col=COL", ")")
eval(parse(text=tx))
}
}
else{
if(!is.null(IMAGE)){
tx<-paste("plot3D::image2D(", "z=z,", toString(x=IMAGE), ")")
eval(parse(text=tx))
}
else{
tx<-paste("plot3D::image2D(", "z=z,", "xlab=xlab,", "ylab=ylab,", "col=COL", ")")
eval(parse(text=tx))
}

}


if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
if(!missing(Z)){
mtextexe<-paste("mtext(","text=zlab,", "line=1,", "font=2,", "cex=2",  ")")
eval(parse(text=mtextexe))
}
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


}
