F74<-function(data, X, Y, Z, type="contour",  COLORS=NULL,
XLAB=NULL, YLAB=NULL, ZLAB=NULL, MAIN=NULL,
XFONT=list(family = "Courier New, monospace", size = 24,  color = "black"),
YFONT=list(family="Courier New, monospace", size=24,  color="black"), 
yaxis=list(title=ylab, titlefont=YFONT), xaxis=list(title=xlab, autotick=TRUE, titlefont=XFONT)){

datos<-data

if(missing(X)){
x<-NULL
}
else{
x<-datos[,X]
if(!is.null(XLAB)) xlab<-XLAB else xlab<-X
}

if(missing(Y)){
y<-NULL
}
else{
y<-datos[,Y]
if(!is.null(YLAB)) ylab<-YLAB else ylab<-Y
}

if(missing(Z)){
z<-datos
}
else{
if(class(Z)=="matrix"){
z<-Z
}

if(class(Z)=="character"){
z<-as.matrix(datos[,Z])
}


}


require(plotly)
if(is.null(x) | is.null(y)){
plotly::plot_ly(x=x, y=y, z=z, type = type, colors=COLORS) %>%
plotly::layout(title = MAIN)
}
else{
plotly::plot_ly(x=x, y=y, z=z, type = type, colors=COLORS) %>%
plotly::layout(title = MAIN, xaxis=xaxis, yaxis=yaxis)
}

}